# CMS管理系统打包工程
## 功能列表
- 添加相关子项目
- 使用gradle进行前后端自动打包
- 增加docker部署
## 子模块添加相关命令
1. 拉取指定分支的子模块
```shell
git submodule add -b master [URL to Git repo]
```

2. 在.gitmodules 文件中设置分支
```shell
git config -f .gitmodules submodule.DbConnector.branch stable
```

其中 DbConnector 是主目录中安装的子目录的名称， stable 是对应要设置的分支名称，此命令根据实际情况修改这两个参数
3. 主目录中找到对应的子模块，切换到对应的分支。其中 project 主项目， submoduleA 子模块， git checkout 切换到我们的对应分支，然后拉取对应分支代码
```shell
cd project/submoduleA
git checkout master
cd ..
git submodule foreach git pull
cd ..
```

4. git submodule的更新
当将已经添加子目录的工程`git clone`下来后，子目录中并无文件存在，若是更新所有的子目录，命令如下：
```shell
git submodule update --init --recursive
```
上述代码段中`--recursive`为递归模式。

5. 若是只更新子目录`git_test_sub1`，则可以使用命令如下：
```shell
git submodule update --init --remote git_test_sub1
git submodule更新子目录下的某个分支
```

6. 若是在子目录添加时并未直接添加子目录的某个分支（`git shumodule`添加某一子目录的分支），使用子目录时却是需要子目录中的某个分支，则进入子目录路径下，执行如下命令：
```shell
git pull origin ns:ns
```
上述代码段中，`origin`为远程主机名，`ns`为远程分支名，`dev`为本地分支名

7. git submodule的删除。当工程中不再需要子模块`git_test_sub1`时，可以执行以下命令：
```shell
git submodule deinit -f git_test_sub1
```
上述命令用于逆初始化子模块`git_test_sub1`，`-f`为强制移除，之后再执行以下命令：
```shell
git rm --cached git_test_sub1
```
- 上述代码段用于清除子目录`git_test_sub1`的缓存

- 当执行完上述两段命令后再执行`git add`、`git commit`和`git push`将代码提交至远程仓库即可。